\section{Electronics}
In order for the ACS to work, there needs to be some sensors and something which
can read the sensors, do some math, and then control a servo or motor. There are
multiple ways of doing this, and this section covers some of the basics needed
for understanding how the electronics fit together and communicate. This
includes communication protocols, how each sensor is used, differences between
microcontrollers, and the basics of how servos are controlled.

\subsection{Microcontrollers}
A microcontroller is the ``brain'' of the ACS. The code you compile is stored and
run here, and the microcontroller is what will read the sensors and control
motors and/or servos. There is more than one way to interface a microcontroller
with peripherals (sensors, motors, etc), which will be covered in more depth in
\ref{Communication Protocols}.

\begin{figure}[H]
    \centering
    \includegraphics[width=0.5\textwidth]{electronics/teensy3_6.jpg}
    \caption[Teensy 3.6]{A Teensy 3.6 is an example of a microcontroller.}
    \label{fig:teensy}
\end{figure}

\subsection{Sensors}
\subsubsection{Altimeter}
An altimeter is used to calculate the altitude, obviously. However in the ACS,
it is also used to calculate the vertical velocity. Reason one is there is much
less noise than the accelerometer, and reason two is it eliminates the need for
frame transformations, assuming you were trying to calculate the velocity by
integrating noisy altimeter data.

\subsubsection{Intertial Measurement Unit - Accelerometer}
The \imu is both for calculating the acceleration, and tracking the rotation of
the rocket. See Section \ref{Coordinate Frames and Transformations} for a review
on how the \imu is used for frame transformations. The biggest issue with the
\imu is the amount of noise in the data, which is the reason for implementing a
Kalman filter (see Section \ref{Kalman Filter}).

\subsection{Communication Protocols} \label{Communication Protocols}
There are a few ways to interface sensors with a microcontroller/computer, each
one has their own advantages and disadvantages. The communication protocol we
most often use is called \isqrc. It is the simplest protocol for
connecting multiple devices to one using only two communication wires (or PCB
tracks, etc.). However, it also the slowest. Other protocols such as SPI are
faster, but require more connections and are limited in the amount of devices it
can talk to; it is also not as convenient to program.

\subsubsection{\isqrc}
The \isqrc protocol only needs two lines to make a connection
to a device, and theoretically up to 128 devices can be connected to the same
two lines. The main device (in this case our microcontroller) is normally called
the master device, and the devices it controls are called slave devices. The two
lines are called the Serial Data (SDA) line and the Serial Clock (SCL) line.

\subsection{Servos}